ClassDefinition (Java Platform SE 8 )
Keywords: java.lang.instrument.ClassDefinition class
Date: 2026-04-24

compact3
java.lang.instrument

## Class ClassDefinition

- java.lang.Object
- - java.lang.instrument.ClassDefinition

-     public final class ClassDefinition
      extends Object

  This class serves as a parameter block to the `Instrumentation.redefineClasses` method. Serves to bind the `Class` that needs redefining together with the new class file bytes.
  Since:
    1.5
  See Also:
    `Instrumentation.redefineClasses(java.lang.instrument.ClassDefinition...)`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ClassDefinition(Class<?> theClass, byte[] theClassFile)` Creates a new `ClassDefinition` binding using the supplied class and class file bytes.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Class<?>` | `getDefinitionClass()` Returns the class.
    `byte[]` | `getDefinitionClassFile()` Returns the array of bytes that contains the new class file.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ClassDefinition

          public ClassDefinition(Class<?> theClass,
                                 byte[] theClassFile)

      Creates a new `ClassDefinition` binding using the supplied class and class file bytes. Does not copy the supplied buffer, just captures a reference to it.
      Parameters:
        `theClass` - the `Class` that needs redefining
        `theClassFile` - the new class file bytes
      Throws:
        `NullPointerException` - if the supplied class or array is `null`.

  - ### Method Detail

    - #### getDefinitionClass

          public Class<?> getDefinitionClass()

      Returns the class.
      Returns:
        the `Class` object referred to.

    - #### getDefinitionClassFile

          public byte[] getDefinitionClassFile()

      Returns the array of bytes that contains the new class file.
      Returns:
        the class file bytes.

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.